<?php
// Zip file class that creates and outputs a Zip file on the fly. No dependencies on external binaries.
// Based on a class found at http://www.granthinkson.com/2005/07/01/create-zip-files-dynamically-using-php/
// which in turn is based on a class found at http://www.zend.com/zend/spotlight/creating-zip-files3.php.

class zipfile
{
    var $datasec = array();
    var $ctrl_dir = array();
    var $eof_ctrl_dir = "\x50\x4b\x05\x06\x00\x00\x00\x00";
    var $old_offset = 0;
    var $Directories = array();

    function add_dir($name) {
        $name = str_replace("\\", '/', $name);
	$myarray = explode('/', $name);
	if ($myarray[count($myarray) - 1] == '') {
	    array_splice($myarray, count($myarray) - 1);
	}
	
	$mypath = '';
	for ($counter = 0; $counter < count($myarray); $counter++) {
	    $mypath = $mypath . $myarray[$counter] . '/';
    	    if (!in_array($mypath, $this->Directories)) {
        	$Directories = $this->Directories + array($mypath);
		$this->add_dir_to_structure($mypath);
	    }
	}
    }

    function add_dir_to_structure($name) {
	$new_offset = $this->old_offset;
	$fr = "\x50\x4b\x03\x04";
	$fr .= "\x0a\x00";
	$fr .= "\x00\x00";
	$fr .= "\x00\x00";
	$fr .= "\x00\x00\x00\x00";

	$fr .= pack('V',0);
	$fr .= pack('V',0);
	$fr .= pack('V',0);
	$fr .= pack('v', strlen($name) );
	$fr .= pack('v', 0 );
	$fr .= $name;
	$fr .= pack('V', 0);
	$fr .= pack('V', 0);
	$fr .= pack('V', 0);

	$output = $fr;
	$new_offset = $new_offset + strlen($output);
	print $output;

	$cdrec = "\x50\x4b\x01\x02";
	$cdrec .="\x00\x00";
	$cdrec .="\x0a\x00";
	$cdrec .="\x00\x00";
	$cdrec .="\x00\x00";
	$cdrec .="\x00\x00\x00\x00";
	$cdrec .= pack('V',0);
	$cdrec .= pack('V',0);
	$cdrec .= pack('V',0);
	$cdrec .= pack('v', strlen($name) );
	$cdrec .= pack('v', 0 );
	$cdrec .= pack('v', 0 );
	$cdrec .= pack('v', 0 );
	$cdrec .= pack('v', 0 );
	$ext = "\x00\x00\x10\x00";
	$ext = "\xff\xff\xff\xff";
	$cdrec .= pack('V', 16 );
	$cdrec .= pack('V', $this -> old_offset );
	$cdrec .= $name;

	$this -> ctrl_dir[] = $cdrec;
	$this -> old_offset = $new_offset;
	return;
    }

    function add_file($data, $name) {
	$new_offset = $this -> old_offset;
	$crc = hash_file('crc32b', $data, true);
	$name = str_replace("\\", '/', $name);
	$len = filesize($data);
	$fr = "\x50\x4b\x03\x04";		// local file header signature
	$fr .= "\x14\x00";			// version needed to extract
	$fr .= "\x00\x00";			// general purpose bit flag
	$fr .= "\x00\x00";			// compression method
	$fr .= "\x00\x00\x00\x00";		
	$fr .= $crc;
	$fr .= pack('V',$len);			// compressed size
	$fr .= pack('V',$len);			// uncompressed size
	$fr .= pack('v', strlen($name) );	// file name length
	$fr .= pack('v', 0 );			// extra field length
	$fr .= $name;				// file name

	$output = $fr;
	$new_offset = $new_offset + strlen($output);
	echo $output;
	$count = @readfile($data);
	$new_offset = $new_offset + $count;
	
	$fr = $crc;
	$fr .= pack('V',$len);
	$fr .= pack('V',$len);
	$output = $fr;
	$new_offset = $new_offset + strlen($output);
	echo $output;

	$cdrec = "\x50\x4b\x01\x02";
	$cdrec .="\x00\x00";
	$cdrec .="\x14\x00";
	$cdrec .="\x00\x00";
	$cdrec .="\x00\x00";
	$cdrec .="\x00\x00\x00\x00";
	$cdrec .= $crc;
	$cdrec .= pack('V',$len);
	$cdrec .= pack('V',$len);
	$cdrec .= pack('v', strlen($name) );
	$cdrec .= pack('v', 0 );
	$cdrec .= pack('v', 0 );
	$cdrec .= pack('v', 0 );
	$cdrec .= pack('v', 0 );
	$cdrec .= pack('V', 32 );
	$cdrec .= pack('V', $this -> old_offset );

	$this -> old_offset = $new_offset;

	$cdrec .= $name;
	$this -> ctrl_dir[] = $cdrec;
    }

    function finish() {
	$ctrldir = implode($this -> ctrl_dir);

	echo $ctrldir.
	$this -> eof_ctrl_dir .
	pack('v', sizeof($this -> ctrl_dir)) .
	pack('v', sizeof($this -> ctrl_dir)) .
	pack('V', strlen($ctrldir)) .
	pack('V', $this -> old_offset) .
	"\x00\x00";
    }
}
?>
